#include <sourcemod>
#include <sdktools>
#include <dhooks>

public Plugin myinfo =
{
	name = "Crashfix GetItemInLoadout",
	author = "PerfectLaugh",
	description = "",
	version = "20190208",
	url = ""
};

Handle hGetInventoryItemByItemID;
Handle hGetItemInLoadout;

int g_Offset = -1;

public void OnPluginStart()
{
    Handle hGameData = LoadGameConfigFile("crashfix_getiteminloadout.games");
    if (hGameData == null) {
        SetFailState("Couldn't find crashfix_getiteminloadout.games gamedata.");
    }
    g_Offset = GameConfGetOffset(hGameData, "Padding");
    if (g_Offset == -1) {
        SetFailState("Couldn't find Padding in gamedata.");
    }

    StartPrepSDKCall(SDKCall_Raw);
    if (!PrepSDKCall_SetFromConf(hGameData, SDKConf_Signature, "CPlayerInventory::GetInventoryItemByItemID")) {
        SetFailState("Couldn't find SDKCall for CPlayerInventory::GetInventoryItemByItemID.");
    }
    PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Plain);
    PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_Plain);
    PrepSDKCall_SetReturnInfo(SDKType_PlainOldData, SDKPass_Plain);
    hGetInventoryItemByItemID = EndPrepSDKCall();

    hGetItemInLoadout = DHookCreateDetour(Address_Null, CallConv_THISCALL, ReturnType_Int, ThisPointer_Address);
    if (!hGetItemInLoadout) {
        SetFailState("Failed to setup detour for GetItemInLoadout");
    }
    if (!DHookSetFromConf(hGetItemInLoadout, hGameData, SDKConf_Signature, "CCSPlayerInventory::GetItemInLoadout")) {
        SetFailState("Failed to load CCSPlayerInventory::GetItemInLoadout signature from gamedata");
    }
    DHookAddParam(hGetItemInLoadout, HookParamType_Int);
    DHookAddParam(hGetItemInLoadout, HookParamType_Int);
    if (!DHookEnableDetour(hGetItemInLoadout, false, Detour_OnGetItemInLoadout)) {
        SetFailState("Failed to detour CCSPlayerInventory::GetItemInLoadout.");
    }
    delete hGameData;
}

public MRESReturn Detour_OnGetItemInLoadout(Address pThis, Handle hReturn, Handle hParams)
{
    int a2 = DHookGetParam(hParams, 1);
    int a3 = DHookGetParam(hParams, 2);
    if (a2 > 3 || a3 > 56) {
        return MRES_Ignored;
    }
    int idx = a2 * 57 + a3;
    int itemid1 = LoadFromAddress(pThis + view_as<Address>(g_Offset + idx * 8), NumberType_Int32);
    int itemid2 = LoadFromAddress(pThis + view_as<Address>(g_Offset + 4 + idx * 8), NumberType_Int32);
    if (itemid1 == 0 && itemid2 == 0) {
        return MRES_Ignored;
    }
    Address item = SDKCall(hGetInventoryItemByItemID, pThis, itemid1, itemid2);
    if (item == Address_Null) {
        DHookSetReturn(hReturn, Address_Null);
        LogMessage("Captured Null Item. Superceding...");
        return MRES_Supercede;
    }
    return MRES_Ignored;
}